
public abstract class HashTable {
	HashTableElem[] a;
	double caricoMax;
	int size;
	
	static boolean isPrime(int m){
		for (int i=2; i*i<=m; i++){
			if (m%i==0) return false;
		}
		return true;
	}
	
	static private int cercaPrimo (int m){
		while (true){
			if (isPrime(m)) return m;
			m++;
		}
	}
	
	public HashTable (int m, double caricoMax){
		this.caricoMax=caricoMax;
		m=cercaPrimo(m);
		a= new HashTableElem[m];
		for (int i=0; i<m; i++){
			a[i]=new EmptyHashTableElem();
		}
		size=0;
		//System.out.println ("Creata tabella di dimensione "+m);
	}
	
	protected abstract int H(int key, int i);
	
	public void insert (int x){
		if (search(x)) return;
		boolean inserito=false;
		int i=0;
		do{
			int pos = H(x, i);
			if (a[pos] instanceof EmptyHashTableElem
				||a[pos] instanceof DeletedHashTableElem){
				a[pos]= new IntHashTableElem(x);
				inserito=true;
			}
			i++;
		} while (!inserito && i<a.length);
		if (i>=a.length){
			System.out.println ("ERRORE: tabella piena");
			System.out.println ("size = "+size);
			System.out.println ("a.length ="+a.length);
		}
		size++;
		if ((double)size/a.length >=caricoMax) {
			redim(a.length*3);
		}
	}
	
	public boolean search (int x){		
		for (int i=0; i<a.length; i++){
			int pos = H(x, i);
			if (a[pos] instanceof EmptyHashTableElem){
				return false;
			}
			if (a[pos] instanceof IntHashTableElem &&
				((IntHashTableElem)a[pos]).key==x){
					return true;
				}
		}
		return false;
	}
	
	public void delete (int x){
		for (int i=0; i<a.length; i++){
			int pos = H(x, i);
			if (a[pos] instanceof EmptyHashTableElem){
				return;
			}
			if (a[pos] instanceof IntHashTableElem &&
				((IntHashTableElem)a[pos]).key==x){
					size--;
					a[pos]=new DeletedHashTableElem();
					return;
				}
		}
		
	}
	
	protected abstract void redim(int newDim);
	
	protected void riversa(HashTable nuova){
		//System.out.println ("Riversamento per redim");
		for (int i=0; i<a.length; i++){
			if (a[i] instanceof IntHashTableElem){
				nuova.insert(((IntHashTableElem)a[i]).key);
			}
		}
	}
	
		/*ListHashTable ht=new ListHashTable(newDim);
		for (int i=0; i<a.length; i++){
			for (Elem e=a[i].head; e!=null; e=e.next){
				ht.insert(e.key);
			}
		}
		a=ht.a;
		*/				
	
	
	

}
