
public class ListHashTable {
	private List[] a;
	private int size; //elementi presenti in tabella
	private double caricoMax;
	
	static boolean isPrime(int m){
		for (int i=2; i*i<=m; i++){
			if (m%i==0) return false;
		}
		return true;
	}
	
	static private int cercaPrimo (int m){
		while (true){
			if (isPrime(m)) return m;
			m++;
		}
	}
	
	public ListHashTable (int m, double caricoMax){
		m=cercaPrimo(m);
		a= new List[m];
		for (int i=0; i<m; i++){
			a[i]=new List();
		}
		size=0;
		this.caricoMax=caricoMax;
	}
	
	private int H(int key){
		return key%a.length;
	}
	
	public void insert (int x){
		a[H(x)].insert(x);
		size++;
		if ((double)size/a.length >=caricoMax) {
			redim((int)(a.length*2*caricoMax));
		}
	}
	
	public boolean search (int x){
		return a[H(x)].search(x);
	}
	
	public void delete (int x){
		if (search(x)){
			size--;
			a[H(x)].delete(x);
		}
	}
	
	private void redim(int newDim){
		ListHashTable ht=new ListHashTable(newDim, caricoMax);
		for (int i=0; i<a.length; i++){
			for (Elem e=a[i].head; e!=null; e=e.next){
				ht.insert(e.key);
			}
		}
		a=ht.a;				
	}
	

}
