
public class Tree {
	Node root;
	
	public void insert (int key){
		Node z = new Node (key);
		Node y=null;
		Node x=root;
		while (x!=null){
			y=x;
			if (x.key<key){
				x=x.right;
			} else {
				x=x.left;
			}
		}
		z.p=y;
		if (y==null){
			root=z;
		} else if (key<y.key) {
			y.left=z;
		} else {
			y.right=z;
		}
	}
	
	public void inOrderWalk(){
		if (root != null){
			Tree sx=new Tree();
			sx.root=root.left;
			sx.inOrderWalk();
			
			System.out.println(root.key);
			
			Tree dx=new Tree();
			dx.root=root.right;
			dx.inOrderWalk();
		}
	}
	
	public int getHeight(){
		if (root==null)
			return 0;
		Tree sx=new Tree();
		sx.root=root.left;
		Tree dx=new Tree();
		dx.root=root.right;
		int hSx=sx.getHeight();
		int hDx=dx.getHeight();
		if (hSx>hDx){
			return hSx+1;
		} else {
			return hDx+1;
		}
	}
	
	private void transplant (Node u, Node v){
		if (u.p==null) {
			root=v;
		} else if (u==u.p.left){
			u.p.left=v;
		} else {
			u.p.right=v;
		}
		if (v!=null){
			v.p=u.p;
		}
	}
	
	private boolean appartiene(Node u){
		//NON assumiamo che le chiavi siano distinte
		if (u==null || root==null) return false;
		if (root==u) return true;
		if (u.key>root.key){
			Tree dx=new Tree();
			dx.root=this.root.right;
			return dx.appartiene(u);
		} else if (u.key<root.key){
			Tree sx=new Tree();
			sx.root=this.root.left;
			return sx.appartiene(u);
		} else {
			Tree dx=new Tree();
			dx.root=this.root.right;
			Tree sx=new Tree();
			sx.root=this.root.left;
			return dx.appartiene(u)||sx.appartiene(u);
		}
	}
	
	public Node minimum(){
		Node x=root;
		if (x==null) return null;
		while (x.left!=null) {
			x=x.left;
		}
		return x;
	}
	
	/* esercizio: implementare minimum 
	 * in modo ricorsivo
	 */
	
	public void delete (Node z){
		if (!appartiene(z)) return;
		if (z.left==null){
			transplant(z, z.right);
		} else if (z.right==null){
			transplant(z, z.left);
		} else {
			Tree t=new Tree();
			t.root=z.right;
			Node y = t.minimum();
			if (y.p!=z){
				transplant(y, y.right);
				y.right=z.right;
				y.right.p=y;
			}
			transplant(z, y);
			y.left=z.left;
			y.left.p=y;
		}
	}
	
	/*
	 * restituisce null se key non è presente
	 * altrimenti uno dei nodi in cui è presente
	 */
	public Node search (int key){
		if (root==null) return null;
		if (root.key==key) return root;
		if (key>root.key){
			Tree dx=new Tree();
			dx.root=this.root.right;
			return dx.search(key);
		} else {
			Tree sx=new Tree();
			sx.root=this.root.left;
			return sx.search(key);
		}
	}
	
	public Node search_iterative (int key){
		Node x = root;
		while (x!=null && x.key!=key){
			if (key>x.key){
				x=x.right;
			} else {
				x=x.left;
			}
		}
		return x;
	}
	
	

}
